#include <windows.h>
#include <string.h>

#pragma warning(disable:4996) // prevent warning 4996 about sprintf and some other functions too old

#define mem_id "IPC_XFER_LIB_SHARED_MEMORY"
HANDLE hWritePage,hReadPage;
char *wr_mem,*rd_mem;

int open_mem_wr(void)
{
	hWritePage = CreateFileMappingA(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, 1024, mem_id);
	if (hWritePage==INVALID_HANDLE_VALUE) { return -1; } // error
	wr_mem = (char*)MapViewOfFile(hWritePage, FILE_MAP_WRITE, 0, 0, 1024);
	wr_mem[0]=1; // opened
	return 0;
}

int open_mem_rd(void)
{
	hReadPage = CreateFileMappingA(INVALID_HANDLE_VALUE, NULL, FILE_MAP_READ, 0, 1024, mem_id);
	if (hReadPage==INVALID_HANDLE_VALUE) { return -1; } // error
	rd_mem = (char*)MapViewOfFile(hReadPage, FILE_MAP_READ, 0, 0, 1024);
	if (rd_mem[0]==0) { return -1; } // error
	return 0;
}

int write_mem(char *buf)
{
	wr_mem[1]=1; // busy
	strcpy(wr_mem+16, buf);
	wr_mem[1]=0;
	return 0;
}

int read_mem(char *buf)
{
	if (rd_mem[0]==0) { return -1; } // error
	for (int t=0;t<10000;t++) { if (rd_mem[1]==0) break; } // busy check
	strcpy(buf, rd_mem+16);
	return 0;
}

int read_mem_check(void)
{
	if (rd_mem[0]==0) { return -1; } // error
	return 0;
}

int close_mem_wr(void)
{
	wr_mem[0]=0; // closed
	UnmapViewOfFile(wr_mem);
	CloseHandle(hWritePage);
	return 0;
}

int close_mem_rd(void)
{
	UnmapViewOfFile(rd_mem);
	CloseHandle(hReadPage);
	return 0;
}
